diff -uNrd ircd-hybrid-6.4.1/src/m_away.c ircd-hyb6.4.1-FDFr5.4/src/m_away.c
--- ircd-hybrid-6.4.1/src/m_away.c	Sat Dec  8 02:06:13 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/m_away.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_away.c,v 1.3 2001/12/08 07:06:13 lusky Exp $
+ *   $Id: m_away.c,v 1.2 2003/05/17 05:47:58 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
@@ -131,11 +131,10 @@
         {
           MyFree(away);
           sptr->user->away = NULL;
+	  /* Instead of never propogating AWAYs, I send them only during
+	   * status change (eg, not-away->away or away->not-away. -JailBird */
+	  sendto_serv_butone(cptr, ":%s AWAY", parv[0]);
         }
-/* some lamers scripts continually do a /away, hence making a lot of
-   unnecessary traffic. *sigh* so... as comstud has done, I've
-   commented out this sendto_serv_butone() call -Dianora */
-/*      sendto_serv_butone(cptr, ":%s AWAY", parv[0]); */
       if (MyConnect(sptr))
         sendto_one(sptr, form_str(RPL_UNAWAY),
                    me.name, parv[0]);
@@ -146,15 +145,15 @@
   
   if (strlen(awy2) > (size_t) TOPICLEN)
     awy2[TOPICLEN] = '\0';
-/* some lamers scripts continually do a /away, hence making a lot of
-   unnecessary traffic. *sigh* so... as comstud has done, I've
-   commented out this sendto_serv_butone() call -Dianora */
-/*  sendto_serv_butone(cptr, ":%s AWAY :%s", parv[0], awy2); */
 
   /* don't use realloc() -Dianora */
 
   if (away)
     MyFree(away);
+  else
+    /* Instead of never propogating AWAYs, I send them only during
+     * status change (eg, not-away->away or away->not-away. -JailBird */
+    sendto_serv_butone(cptr, ":%s AWAY :%s", parv[0], awy2);
 
   away = (char *)MyMalloc(strlen(awy2)+1);
   strcpy(away,awy2);
diff -uNrd ircd-hybrid-6.4.1/src/m_capab.c ircd-hyb6.4.1-FDFr5.4/src/m_capab.c
--- ircd-hybrid-6.4.1/src/m_capab.c	Tue Jul 17 21:37:12 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/m_capab.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_capab.c,v 1.5 2001/07/18 01:37:12 lusky Exp $
+ *   $Id: m_capab.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_close.c ircd-hyb6.4.1-FDFr5.4/src/m_close.c
--- ircd-hybrid-6.4.1/src/m_close.c	Fri Jul 30 00:01:32 1999
+++ ircd-hyb6.4.1-FDFr5.4/src/m_close.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_close.c,v 1.1 1999/07/30 04:01:32 tomh Exp $
+ *   $Id: m_close.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_connect.c ircd-hyb6.4.1-FDFr5.4/src/m_connect.c
--- ircd-hybrid-6.4.1/src/m_connect.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_connect.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_connect.c,v 1.11 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: m_connect.c,v 1.1.1.2 2003/10/09 02:47:15 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_die.c ircd-hyb6.4.1-FDFr5.4/src/m_die.c
--- ircd-hybrid-6.4.1/src/m_die.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_die.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_die.c,v 1.6 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: m_die.c,v 1.1.1.2 2003/10/09 02:47:14 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_encap.c ircd-hyb6.4.1-FDFr5.4/src/m_encap.c
--- ircd-hybrid-6.4.1/src/m_encap.c	Mon Jun 23 23:14:32 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_encap.c	Wed Oct 15 20:38:22 2003
@@ -19,7 +19,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_encap.c,v 1.2 2003/06/24 03:14:32 ievil Exp $
+ *   $Id: m_encap.c,v 1.1.1.1 2003/10/09 02:47:13 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_error.c ircd-hyb6.4.1-FDFr5.4/src/m_error.c
--- ircd-hybrid-6.4.1/src/m_error.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_error.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_error.c,v 1.9 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: m_error.c,v 1.1.1.2 2003/10/09 02:47:14 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_gline.c ircd-hyb6.4.1-FDFr5.4/src/m_gline.c
--- ircd-hybrid-6.4.1/src/m_gline.c	Sun May  4 18:49:28 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_gline.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: m_gline.c,v 1.52 2003/05/04 22:49:28 ievil Exp $
+ *  $Id: m_gline.c,v 1.8 2003/10/10 04:45:49 jailbird Exp $
  */
 #include "m_commands.h"
 #include "m_gline.h"
@@ -48,8 +48,6 @@
 #include <fcntl.h>
 
 
-#ifdef GLINES
-
 /* external variables */
 extern ConfigFileEntryType ConfigFileEntry; /* defined in ircd.c */
 
@@ -73,15 +71,10 @@
 
 static int majority_gline(aClient*, const char *,const char *, const char *, 
                           const char* serv_name,
-                          const char *,const char *,const char *
-#ifdef GLINE_REASON_FIRST
-                          , GLINE_PENDING **
-#endif 
-                          ); 
+                          const char *,const char *,const char *); 
 
 static int invalid_wildcard(char *, char *);
 static int invalid_gline(struct Client *, char *, char *, char *, int);
-#endif
 
 /*
  * m_gline()
@@ -90,7 +83,7 @@
  * output       -
  * side effects -
  *
- * Place a G line if 3 opers agree on the identical user@host
+ * Place a G line if 2 opers agree on the identical user@host
  * 
  */
 /* Allow this server to pass along GLINE if received and
@@ -108,22 +101,15 @@
   const char* oper_server;      /* server of oper requesting GLINE */
   char *user, *host;            /* user and host of GLINE "victim" */
   char *reason;                 /* reason for "victims" demise */
-#ifdef GLINES
   char buffer[512];
   const char *current_date;
   char tempuser[USERLEN + 2];
   char temphost[HOSTLEN + 1];
   aConfItem *aconf;
-#ifdef GLINE_REASON_FIRST  
-  GLINE_PENDING * tmp_gline_pending_ptr;
-#endif /* GLINE_REASON_FIRST */
-#endif /* GLINES */
 
-   
   /* its one of our local clients doing a /gline */
   if(MyClient(sptr))
     {
-#ifdef GLINES
       /* Only globals can apply Glines */
       if (!IsOper(sptr))
         {
@@ -210,19 +196,14 @@
                          user,
                          host,
                          reason);
-#else
-      sendto_one(sptr,":%s NOTICE %s :GLINE disabled",me.name,parv[0]);  
-#endif
     }
   /* its not my client, its something else */
   else
     {
-#ifdef GLINES
       struct Client *acptr;
-#endif      
       
       /* if its not my client, and its not a server.. we dont wanna know */
-      if(!IsServer(sptr))
+      if(!IsServer(sptr)&&!IsSLine(sptr))
         return(0);
 
       /* Always good to be paranoid about arguments */
@@ -242,7 +223,6 @@
 			 oper_name,oper_username,oper_host,oper_server,
 			 user, host, reason);
 
-#ifdef GLINES
       /* check theres enough non-wildcard chars after we send it, our limit
        * might be different to other peoples.. */
       if(invalid_wildcard(user, host))
@@ -264,19 +244,11 @@
        */
       
       if(!acptr)
-#ifdef NO_FAKE_GLINES
-        return 0;
-#else	
         acptr=sptr;
-#endif /* NO_FAKE_GLINES */
 
       if(invalid_gline(acptr, user, host, reason, 0))
         return 0;
-	
-#endif /* GLINES */     
-      
     }
-#ifdef GLINES
 
    log_gline_request(oper_name,oper_username,oper_host,oper_server,
                      user,host,reason);
@@ -290,19 +262,15 @@
                   host,
                   reason);
 
-  /* If at least 3 opers agree this user should be G lined then do it */
-  if(majority_gline(sptr,
+  /* If at least 2 opers agree this user should be G lined then do it */
+  if(IsSLine(sptr)||majority_gline(sptr,
                     oper_name,
                     oper_username,
                     oper_host,
                     oper_server,
                     user,
                     host,
-                    reason
-#ifdef GLINE_REASON_FIRST
-                    ,&tmp_gline_pending_ptr
-#endif                    
-                    ))
+                    reason))
     {
       current_date = smalldate((time_t) 0);
           
@@ -311,11 +279,7 @@
       DupString(aconf->host, host);
 
       ircsprintf(buffer, "%s (%s)",
-#ifdef GLINE_REASON_FIRST
-                 tmp_gline_pending_ptr->reason1 
-#else
                  reason
-#endif      
                  ,current_date);
       
       DupString(aconf->passwd, buffer);
@@ -330,12 +294,7 @@
                      oper_server,
                      user,
                      host,
-#ifdef GLINE_REASON_FIRST
-                     tmp_gline_pending_ptr->reason1
-#else
-                     reason
-#endif
-                     );
+                     reason);
       
       rehashed = YES;
       dline_in_progress = NO;
@@ -343,12 +302,10 @@
 
       return 0;
     }
-#endif  
   return 0;
 }
 
 
-#ifdef GLINES
 /*
  * invalid_wildcard()
  */
@@ -536,17 +493,6 @@
     return;
 
   ircsprintf(buffer, "#%s!%s@%s on %s [%s]\n",
-                   gline_pending_ptr->oper_nick2,
-                   gline_pending_ptr->oper_user2,
-                   gline_pending_ptr->oper_host2,
-                   gline_pending_ptr->oper_server2,
-                   (gline_pending_ptr->reason2)?
-                   (gline_pending_ptr->reason2):"No reason");
-
-  if (safe_write(sptr, filenamebuf, out, buffer))
-    return;
-
-  ircsprintf(buffer, "#%s!%s@%s on %s [%s]\n",
                    oper_nick,
                    oper_user,
                    oper_host,
@@ -557,12 +503,7 @@
     return;
 
   ircsprintf(buffer, "K:%s:%s:%s\n", host,user,
-#ifdef GLINE_REASON_FIRST
-                   gline_pending_ptr->reason1
-#else  
-                   reason
-#endif  
-                   );
+                   reason);
                    
   if (safe_write(sptr,filenamebuf,out,buffer))
     return;
@@ -721,23 +662,7 @@
                      gline_pending_ptr->host,
                      gline_pending_ptr->reason1);
 
-          if(gline_pending_ptr->oper_nick2[0])
-            {
-              tmptr = localtime(&gline_pending_ptr->time_request2);
-              strftime(timebuffer, MAX_DATE_STRING, "%Y/%m/%d %H:%M:%S", tmptr);
-              sendto_one(sptr,
-              ":%s NOTICE %s :2) %s!%s@%s on %s requested gline at %s for %s@%s [%s]",
-                         me.name,sptr->name,
-                         gline_pending_ptr->oper_nick2,
-                         gline_pending_ptr->oper_user2,
-                         gline_pending_ptr->oper_host2,
-                         gline_pending_ptr->oper_server2,
-                         timebuffer,
-                         gline_pending_ptr->user,
-                         gline_pending_ptr->host,
-                         gline_pending_ptr->reason2);
-            }
-          gline_pending_ptr = gline_pending_ptr->next;
+	  gline_pending_ptr = gline_pending_ptr->next;
         }
       sendto_one(sptr,":%s NOTICE %s :End of Pending G-lines", me.name,
                  sptr->name);
@@ -779,6 +704,7 @@
 
               if(kill_list_ptr->passwd)
                 reason = kill_list_ptr->passwd;
+
               else
                 reason = "No Reason";
 
@@ -879,7 +805,6 @@
           tmp_pending_ptr = gline_pending_ptr;
           gline_pending_ptr = gline_pending_ptr->next;
           MyFree(tmp_pending_ptr->reason1);
-          MyFree(tmp_pending_ptr->reason2);
           MyFree(tmp_pending_ptr);
         }
       else
@@ -917,7 +842,6 @@
   strncpy_irc(pending->user, user, USERLEN);
   strncpy_irc(pending->host, host, HOSTLEN);
   DupString(pending->reason1, reason);
-  pending->reason2 = NULL;
 
   pending->last_gline_time = CurrentTime;
   pending->time_request1 = CurrentTime;
@@ -932,11 +856,11 @@
  * inputs       - oper_nick, oper_user, oper_host, oper_server
  *                user,host reason
  *
- * output       - YES if there are 3 different opers on 3 different servers
+ * output       - YES if there are 2 different opers on 2 different servers
  *                agreeing to this gline, NO if there are not.
  * Side effects -
  *      See if there is a majority agreement on a GLINE on the given user
- *      There must be at least 3 different opers agreeing on this GLINE
+ *      There must be at least 2 different opers agreeing on this GLINE
  *
  *      Expire old entries.
  */
@@ -948,11 +872,7 @@
                           const char* oper_server,
                           const char *user,
                           const char *host,
-                          const char *reason
-#ifdef GLINE_REASON_FIRST
-                          , GLINE_PENDING ** tmp_gline_pending_ptr
-#endif
-                          )
+                          const char *reason)
 {
   GLINE_PENDING* gline_pending_ptr;
 
@@ -980,43 +900,18 @@
               /* This oper or server has already "voted" */
               sendto_realops("oper or server has already voted");
               return NO;
-            }
+           }
 
-          if(gline_pending_ptr->oper_user2[0] != '\0')
+          if(gline_pending_ptr->oper_user1[0] != '\0')
             {
-              /* if two other opers on two different servers have voted yes */
-
-              if(((irccmp(gline_pending_ptr->oper_user2,oper_user)==0) &&
-                  (irccmp(gline_pending_ptr->oper_host2,oper_host)==0)) ||
-                  (irccmp(gline_pending_ptr->oper_server2,oper_server)==0))
-                {
-                  /* This oper or server has already "voted" */
-                  sendto_realops("oper or server has already voted");
-                  return NO;
-                }
-
               if(find_is_glined(host, user))
                 return NO;
 
               log_gline(sptr,sptr->name,gline_pending_ptr,
                         oper_nick,oper_user,oper_host,oper_server,
                         user,host,reason);
-#ifdef GLINE_REASON_FIRST
-              *tmp_gline_pending_ptr = gline_pending_ptr;
-#endif
               return YES;
             }
-          else
-            {
-              strncpy_irc(gline_pending_ptr->oper_nick2, oper_nick, NICKLEN);
-              strncpy_irc(gline_pending_ptr->oper_user2, oper_user, USERLEN);
-              strncpy_irc(gline_pending_ptr->oper_host2, oper_host, HOSTLEN);
-              DupString(gline_pending_ptr->reason2, reason);
-              gline_pending_ptr->oper_server2 = find_or_add(oper_server);
-              gline_pending_ptr->last_gline_time = CurrentTime;
-              gline_pending_ptr->time_request2 = CurrentTime;
-              return NO;
-            }
         }
     }
   /* Didn't find this user@host gline in pending gline list
@@ -1044,4 +939,3 @@
   glines = aconf;
 }
 
-#endif /* GLINES */
diff -uNrd ircd-hybrid-6.4.1/src/m_help.c ircd-hyb6.4.1-FDFr5.4/src/m_help.c
--- ircd-hybrid-6.4.1/src/m_help.c	Thu Jul 29 03:11:48 1999
+++ ircd-hyb6.4.1-FDFr5.4/src/m_help.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_help.c,v 1.1 1999/07/29 07:11:48 tomh Exp $
+ *   $Id: m_help.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_htm.c ircd-hyb6.4.1-FDFr5.4/src/m_htm.c
--- ircd-hybrid-6.4.1/src/m_htm.c	Mon Nov 19 01:34:13 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/m_htm.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_htm.c,v 1.3 2001/11/19 06:34:13 db Exp $
+ *   $Id: m_htm.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_idle.c ircd-hyb6.4.1-FDFr5.4/src/m_idle.c
--- ircd-hybrid-6.4.1/src/m_idle.c	Wed Dec 31 19:00:00 1969
+++ ircd-hyb6.4.1-FDFr5.4/src/m_idle.c	Wed Oct 15 20:38:22 2003
@@ -0,0 +1,124 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, src/m_idle.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_idle.c,v 1.1 2003/05/17 05:47:58 jailbird Exp $
+ */
+#include <stdlib.h>
+#include "m_commands.h"
+#include "client.h"
+#include "ircd.h"
+#include "motd.h"
+#include "msg.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_conf.h"
+
+/*
+ * m_functions execute protocol messages on this server:
+ *
+ *      cptr    is always NON-NULL, pointing to a *LOCAL* client
+ *              structure (with an open socket connected!). This
+ *              identifies the physical socket where the message
+ *              originated (or which caused the m_function to be
+ *              executed--some m_functions may call others...).
+ *
+ *      sptr    is the source of the message, defined by the
+ *              prefix part of the message if present. If not
+ *              or prefix not found, then sptr==cptr.
+ *
+ *              (!IsServer(cptr)) => (cptr == sptr), because
+ *              prefixes are taken *only* from servers...
+ *
+ *              (IsServer(cptr))
+ *                      (sptr == cptr) => the message didn't
+ *                      have the prefix.
+ *
+ *                      (sptr != cptr && IsServer(sptr) means
+ *                      the prefix specified servername. (?)
+ *
+ *                      (sptr != cptr && !IsServer(sptr) means
+ *                      that message originated from a remote
+ *                      user (not local).
+ *
+ *              combining
+ *
+ *              (!IsServer(sptr)) means that, sptr can safely
+ *              taken as defining the target structure of the
+ *              message in this server.
+ *
+ *      *Always* true (if 'parse' and others are working correct):
+ *
+ *      1)      sptr->from == cptr  (note: cptr->from == cptr)
+ *
+ *      2)      MyConnect(sptr) <=> sptr == cptr (e.g. sptr
+ *              *cannot* be a local connection, unless it's
+ *              actually cptr!). [MyConnect(x) should probably
+ *              be defined as (x == x->from) --msa ]
+ *
+ *      parc    number of variable parameter strings (if zero,
+ *              parv is allowed to be NULL)
+ *
+ *      parv    a NULL terminated list of parameter pointers,
+ *
+ *                      parv[0], sender (prefix string), if not present
+ *                              this points to an empty string.
+ *                      parv[1]...parv[parc-1]
+ *                              pointers to additional parameters
+ *                      parv[parc] == NULL, *always*
+ *
+ *              note:   it is guaranteed that parv[0]..parv[parc-1] are all
+ *                      non-NULL pointers.
+ */
+
+/*
+ * m_idle - Resets an oper's idle timer
+ *      parv[0] = sender prefix
+ *      parv[1] = idle time
+ *
+ * Original idea and code by Runt, clean-up and oper check by JailBird.
+ */
+#ifdef IDLE_RESET
+int m_idle(struct Client *cptr, struct Client *sptr, int parc, char *parv[])
+{
+  time_t	last = 0;
+
+  if (parc < 2) {
+      sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
+                 me.name, parv[0], "IDLE");
+      return 0;
+  }
+  
+  if (!IsPerson(sptr) || !MyClient(sptr))
+      return 0;
+
+  if (!IsAnOper(sptr)) {
+      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+      return 0;
+  }
+
+  last = atol(parv[1]);
+  if (last && CurrentTime - last < sptr->user->last && last > 0)
+    sptr->user->last = CurrentTime - last;
+   
+  return 0;
+}
+#endif /* IDLE_RESET */
diff -uNrd ircd-hybrid-6.4.1/src/m_info.c ircd-hyb6.4.1-FDFr5.4/src/m_info.c
--- ircd-hybrid-6.4.1/src/m_info.c	Tue Jul 17 21:37:13 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/m_info.c	Wed Oct 15 20:38:22 2003
@@ -1,7 +1,7 @@
 /*
  * m_info.c 
  *
- * $Id: m_info.c,v 1.41 2001/07/18 01:37:13 lusky Exp $
+ * $Id: m_info.c,v 1.2 2003/05/17 05:47:58 jailbird Exp $
  */
 #define DEFINE_M_INFO_DATA
 #include "m_commands.h"
@@ -45,8 +45,10 @@
 
     if (!IsAnOper(sptr))
     {
+#ifndef INFO_OPER_ONLY
       /* reject non local requests */
       if (!MyConnect(sptr))
+#endif
         return 0;
       if ((last_used + PACE_WAIT) > CurrentTime)
       {
diff -uNrd ircd-hybrid-6.4.1/src/m_ison.c ircd-hyb6.4.1-FDFr5.4/src/m_ison.c
--- ircd-hybrid-6.4.1/src/m_ison.c	Thu Oct 14 02:14:43 1999
+++ ircd-hyb6.4.1-FDFr5.4/src/m_ison.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_ison.c,v 1.4 1999/10/14 06:14:43 lusky Exp $
+ *   $Id: m_ison.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_kill.c ircd-hyb6.4.1-FDFr5.4/src/m_kill.c
--- ircd-hybrid-6.4.1/src/m_kill.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_kill.c	Sun Nov 16 16:20:41 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_kill.c,v 1.9 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: m_kill.c,v 1.4 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
@@ -232,6 +232,7 @@
 	}
     }
 
+if (!IsSLine(sptr)) {
   if (IsAnOper(sptr)) /* send it normally */
     {
       sendto_realops("Received KILL message for %s. From %s Path: %s!%s", 
@@ -256,6 +257,7 @@
     ilog(L_INFO,"KILL From %s For %s Path %s!%s",
                         parv[0], acptr->name, inpath, path);
 #endif
+}
   /*
   ** And pass on the message to other servers. Note, that if KILL
   ** was changed, the message has to be sent to all links, also
@@ -314,7 +316,10 @@
         }
       else
         killer = path;
+if (!IsSLine(sptr))
       ircsprintf(buf2, "Killed (%s)", killer);
+else
+      ircsprintf(buf2, "%s", killer);
     }
   return exit_client(cptr, acptr, sptr, buf2);
 }
diff -uNrd ircd-hybrid-6.4.1/src/m_kline.c ircd-hyb6.4.1-FDFr5.4/src/m_kline.c
--- ircd-hybrid-6.4.1/src/m_kline.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_kline.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_kline.c,v 1.81 2003/06/24 03:57:16 ievil Exp $
+ *   $Id: m_kline.c,v 1.1.1.2 2003/10/09 02:47:15 jailbird Exp $
  */
 #include "m_commands.h"
 #include "m_kline.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_links.c ircd-hyb6.4.1-FDFr5.4/src/m_links.c
--- ircd-hybrid-6.4.1/src/m_links.c	Wed Jun  6 01:03:17 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/m_links.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_links.c,v 1.7 2001/06/06 05:03:17 db Exp $
+ *   $Id: m_links.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_list.c ircd-hyb6.4.1-FDFr5.4/src/m_list.c
--- ircd-hybrid-6.4.1/src/m_list.c	Sun May  4 13:52:45 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_list.c	Wed Oct 15 20:38:22 2003
@@ -3,7 +3,7 @@
  *   Copyright (C) 1990 Jarkko Oikarinen and
  *                      University of Oulu, Co Center
  *
- * $Id: m_list.c,v 1.5 2003/05/04 17:52:45 db Exp $ 
+ * $Id: m_list.c,v 1.2 2003/05/16 19:57:35 jailbird Exp $ 
  *
  *   This program is free software; you can redistribute it and/or modify
  *   it under the terms of the GNU General Public License as published by
@@ -79,7 +79,11 @@
              (chptr) && (j<hash_get_channel_block(i).links); chptr=chptr->hnextch, j++) {
           if (j<progress2) continue;  /* wind up to listprogress2 */
           if (!sptr->user ||
-              (SecretChannel(chptr) && !IsMember(sptr, chptr)))
+              (SecretChannel(chptr) && !IsMember(sptr, chptr)
+#ifdef OPERS_SEE_PRIV
+              && !IsAnOper(sptr)
+#endif
+              ))
             continue;
           sendto_one(sptr, form_str(RPL_LIST), me.name, parv[0],
                      ShowChannel(sptr, chptr)?chptr->chname:"*",
@@ -116,7 +120,11 @@
         for (j=0, chptr = (struct Channel*)(hash_get_channel_block(i).list);
              (chptr) && (j<hash_get_channel_block(i).links); chptr = chptr->hnextch, j++) {
           if (!sptr->user ||
-              (SecretChannel(chptr) && !IsMember(sptr, chptr)))
+              (SecretChannel(chptr) && !IsMember(sptr, chptr)
+#ifdef OPERS_SEE_PRIV
+              && !IsAnOper(sptr)
+#endif
+              ))
             continue;
           /* EVIL!  sendto_one doesnt return status of any kind!  Forcing us
              to make up yet another stupid client flag (we could just
diff -uNrd ircd-hybrid-6.4.1/src/m_locops.c ircd-hyb6.4.1-FDFr5.4/src/m_locops.c
--- ircd-hybrid-6.4.1/src/m_locops.c	Sun May  4 13:52:45 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_locops.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_locops.c,v 1.4 2003/05/04 17:52:45 db Exp $
+ *   $Id: m_locops.c,v 1.1.1.2 2003/10/09 02:47:15 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_ltrace.c ircd-hyb6.4.1-FDFr5.4/src/m_ltrace.c
--- ircd-hybrid-6.4.1/src/m_ltrace.c	Wed Jan  1 10:20:40 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_ltrace.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_ltrace.c,v 1.10 2003/01/01 15:20:40 ievil Exp $
+ *   $Id: m_ltrace.c,v 1.1.1.2 2003/10/09 02:47:14 jailbird Exp $
  */
 #include "m_commands.h"
 #include "class.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_lusers.c ircd-hyb6.4.1-FDFr5.4/src/m_lusers.c
--- ircd-hybrid-6.4.1/src/m_lusers.c	Mon Apr 15 19:13:02 2002
+++ ircd-hyb6.4.1-FDFr5.4/src/m_lusers.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_lusers.c,v 1.2 2002/04/15 23:13:02 lusky Exp $
+ *   $Id: m_lusers.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_message.c ircd-hyb6.4.1-FDFr5.4/src/m_message.c
--- ircd-hybrid-6.4.1/src/m_message.c	Sat Dec 22 19:06:14 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/m_message.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_message.c,v 1.18 2001/12/23 00:06:14 lusky Exp $
+ *   $Id: m_message.c,v 1.3 2003/05/17 05:47:58 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
@@ -173,7 +173,7 @@
 	    }
 	  else
 	    {
-	      if (!IsMember(sptr, chptr)) /* oper send to hash ! */
+	      if (!IsMember(sptr, chptr) && !IsSLine(sptr)) /* oper send to hash ! */
 		{
 		  send_oper_special(cptr, sptr, cmd, nick, parv[2]);
 		  continue;
@@ -195,12 +195,18 @@
 	      check_for_flud(sptr, NULL, chptr, 1);
 #endif /* FLUD */
 
-	  if (can_send(sptr, chptr) == 0)
+	  if (can_send(sptr, chptr) == 0) {
+            if (MyClient(sptr) && (chptr->mode.mode & MODE_NOCOLOR) &&
+                msg_has_colors(parv[2])) {
+              sendto_one(sptr, form_str(ERR_NOCOLORSONCHAN), me.name, parv[0],
+                         nick, parv[2]);
+	      continue;
+	    }
 	    sendto_channel_butone(cptr, sptr, chptr,
 				  ":%s %s %s :%s",
 				  parv[0], cmd, nick,
 				  parv[2]);
-	  else if (!notice)
+	  } else if (!notice)
 	    sendto_one(sptr, form_str(ERR_CANNOTSENDTOCHAN),
 		       me.name, parv[0], nick);
 	  continue;
diff -uNrd ircd-hybrid-6.4.1/src/m_mode.c ircd-hyb6.4.1-FDFr5.4/src/m_mode.c
--- ircd-hybrid-6.4.1/src/m_mode.c	Sat Jun 14 19:23:42 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/m_mode.c	Sun Nov 16 16:20:21 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_mode.c,v 1.2 2003/06/14 23:23:42 ievil Exp $
+ *   $Id: m_mode.c,v 1.3 2003/10/09 03:49:54 jailbird Exp $
  */
 
 #include "m_commands.h"
@@ -33,6 +33,8 @@
 #include "numeric.h"
 #include "s_user.h"
 #include "send.h"
+#include "struct.h"
+#include "list.h"
 
 /*
  * m_functions execute protocol messages on this server:
